/*****************************************************************************
*                     Copyright (c)  Gemplus Developpement 1992 - 1997
*
* Name        : RFTLPREADER.H
*
* Description : 
*
  Author      : JL-GIRAUD
  Compiler    : Visual C++, C Linux
  Host        : 

* $Id: rftlpreader.h,v 1.3 2000/09/04 15:31:25 giraud Exp $
* $Log: rftlpreader.h,v $
* Revision 1.3  2000/09/04 15:31:25  giraud
* Change buffer size in tlpreader.* and rftlpreader.*
* Add lib/samples clean-up when make clean is entered in lib/
*
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
******************************************************************************
*
* Warning     : 
* Remarks     : 
*
*****************************************************************************/


#ifndef _RFTLP_READER_H
#define _RFTLP_READER_H

/****** Buffer Size ******/
#define RFTLP_ATR_BUF_SIZE 255
#define RFTLP_PW_DOWN_BUF_SIZE 100
#define RFTLP_DATA_BUF_SIZE 600
#define RFTLP_SW_BUF_SIZE 20

/****** RFTLP PART ******/

#define RFTLP_EOT      0x03
#define RFTLP_TRANS_OK 0x60

/* RFTLP ERRORS */ 
  
#define   RFTLP_NO_ERROR                          0x00
#define   RFTLP_UNKNOWN_COMMAND                   0x01
#define   RFTLP_DRIVER_LIMITATION                 0x02
#define   RFTLP_WRONG_ARG_LENGTH                  0x03
#define   RFTLP_COMMAND_UNKNOWN                   0x04
#define   RFTLP_PROTOCOL_ERROR                    0x09
#define   RFTLP_WRONG_ATR                         0x10
#define   RFTLP_WRONG_RD_INS                      0x11
#define   RFTLP_MSG_TOO_LONG                      0x12
#define   RFTLP_READ_ERROR                        0x13
#define   RFTLP_CARD_OFF                          0x15
#define   RFTLP_PROG_VOLT_ERROR                   0x16
#define   RFTLP_UNKNOWN_PROTOCOL1                 0x17
#define   RFTLP_UNKNOWN_PROTOCOL2                 0x18
#define   RFTLP_ILLEGAL_ACCESS                    0x19
#define   RFTLP_LENGTH_ERROR                      0x1A
#define   RFTLP_WRONG_NB_OF_PARAM                 0x1B
#define   RFTLP_TCK_ERROR                         0x1D
#define   RFTLP_PROTECTION_ERROR                  0x1E
#define   RFTLP_WRONG_DATA                        0x1F
#define   RFTLP_UNKNOWN_CARD_PROTOCOL             0xA0
#define   RFTLP_CARD_MUTE                         0xA2
#define   RFTLP_CARD_PARITY_ERROR                 0xA3
#define   RFTLP_CARD_WRONG_PROCEDURE_BYTE         0xE4
#define   RFTLP_TRANSFERT_TO_CARD_INTERRUPTED     0xE5
#define   RFTLP_CARD_RETURNED_ERROR               0xE7
#define   RFTLP_CARD_REMOVED                      0xF7
#define   RFTLP_SHORT_CIRCUIT                     0xF8
#define   RFTLP_CARD_ABSENT                       0xFB

/*****  RFTLP COMMANDS *****/

extern const char RFTLP_POWER_DOWN[9];
extern const char RFTLP_POWER_UP[15];

/* RFTLP offsets in messages */
#define RFTLP_ACK_OFF           0
#define RFTLP_LENGTH_OFF        2
#define RFTLP_CMD_OFF           4
#define RFTLP_DATA_OFF          6

/*#define RFTLP_ATR_LENGTH_OFF    10*/
#define RFTLP_ATR_OFF           6 /* in chars */
#define RFTLP_ATR_LENGTH_ADJUST 0  /* in bytes */

int RFTLPResetCardAscii(TYPE_HANDLE fd, char* atr, int length);

int RFTLPResetCardBinary(TYPE_HANDLE fd, unsigned char* atr, int length);

int RFTLPGetReaderResponse(TYPE_HANDLE fd, char *buffer, int length);

t_rd_error RFTLPTrError(int reader_error);

int RFTLPSendIncomingAPDUBinary(TYPE_HANDLE fd,
	unsigned char CLA,
	unsigned char INS,
	unsigned char P1,
	unsigned char P2,
	unsigned char L,
	const unsigned char *data_in,
	unsigned char *ad_SW1,
	unsigned char *ad_SW2);

int RFTLPSendOutgoingAPDUBinary(TYPE_HANDLE fd,
	unsigned char CLA,
	unsigned char INS,
	unsigned char P1,
	unsigned char P2,
	unsigned char L,
	unsigned char *data_out,
	unsigned char *ad_SW1,
	unsigned char *ad_SW2);

int RFTLPSendIncomingOutgoingAPDUBinary(TYPE_HANDLE fd,
	unsigned char CLA,
	unsigned char INS,
	unsigned char P1,
	unsigned char P2,
	unsigned char L_in,
	const unsigned char *data_in,
	unsigned char L_out,
	unsigned char *data_out,
	unsigned char *ad_SW1,
	unsigned char *ad_SW2);

int RFTLPSendIncomingAPDUAscii(TYPE_HANDLE fd, const char* APDU_Data,
	char* ad_response, int resp_length);

int RFTLPSendOutgoingAPDUAscii(TYPE_HANDLE fd,  const char* APDU_Data,  
	char* ad_response, int resp_length);

int RFTLPSendIncomingOutgoingAPDUAscii(TYPE_HANDLE fd, 
	const char* APDU_Data, char* ad_response, int resp_length);

int RFTLPPowerDown(TYPE_HANDLE fd);

#endif

