/*****************************************************************************
*               Copyright (c) Gemplus Card International 1997
*
* Name        : serial.c
*
* Description : Homogenization of read-write function parameters

  Author      : L.GAUTERON
  Compiler    : Visual C++
  Host        : Windows 9x,NT
*
* $Id: serial.c,v 1.3 2000/12/11 17:53:30 rousseau Exp $
* $Log: serial.c,v $
* Revision 1.3  2000/12/11 17:53:30  rousseau
* Added a 5 seconds timeout if no reader present
*
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
******************************************************************************
*
* Warning     : 
*
* Remarks     : 
*
*****************************************************************************/

#include "reader.h"
#include "serial.h"

#ifndef WIN32
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#endif

#ifdef WIN32
int WriteCom (TYPE_HANDLE fd, LPCVOID lpBuffer, DWORD dwNbByte)
{
	DWORD dwWritten;

	if (!WriteFile (fd,lpBuffer,dwNbByte,&dwWritten,0))
		return -1;

	return (int) dwWritten;

} /* WriteCom */

int ReadCom  (TYPE_HANDLE fd, LPVOID  lpBuffer, DWORD dwNbByte)
{
	DWORD dwRead;

	if (!ReadFile (fd,lpBuffer,dwNbByte,&dwRead,0))
		return -1;

	return dwRead;
} /* ReadCom */

#else

int read_with_timeout(TYPE_HANDLE fd, char  *buffer, int length)
{
	fd_set fdset;
	struct timeval timeout;
	int res;

	/* timeout 5 seconds */
	timeout.tv_sec = 5;
	timeout.tv_usec = 0;

	FD_ZERO(&fdset);
	FD_SET(fd, &fdset);
	res = select(fd+1, &fdset, NULL, NULL, &timeout);

	if (res)
		return read(fd, buffer, length);
	else
		return -1;
} /* read_with_timeout */

#endif

