/*
 * Ludovic Rousseau
 *
 * ven sep 22 17:22:16 CEST 2000
 *
 * $Id: reset_tlp.c,v 1.3 2000/12/20 08:00:28 rousseau Exp $
 *
 */

#define HELP_TEXT \
"Reset the GCR from GBP (Gemplus Bloc Protocol) to TLP \n\
\n\
Some Gemplus programs (like wingcr) uses the GBP protocol\n\
The smart card reader does not come back to TLP mode after using GBP\n\
We need to send a GBP reset command to set the reader back to TLP mode"

#include <stdio.h>

#define DEVICE "/dev/screader"

int main(int argc, char *argv[])
{
	FILE *fd;

	if (argc > 1)
	{
		if (strcmp(argv[1], "--version") == 0)
		{
			puts("reset_tlp 1.0");
			return 1;
		}

		if (strcmp(argv[1], "--help") == 0)
		{
			puts(HELP_TEXT);
			return 1;
		}
	}

	if ((fd = fopen(DEVICE, "w")) == NULL)
	{
		perror("fopen");
		return 1;
	}

	fprintf(fd, "%cc%c%c%c%c%c%c%c", 0x42,0x00,0x04,0x0C,0x00,0x00,0x00,0x4A);
	fclose (fd);

	return 0;
} /* main */

